#!/usr/local/bin/python

import string, sys, YHeroic

myLib = YHeroic.YHeroic('localhost',20044)

response = myLib.addUserModel("Michal","python","%PYTHON\n% $Id: therm-rt.pl,v 1.11 2009-05-31 12:26:57 esimon Exp $\n%\n% Copyright 2004-9 by Grzegorz J. Nalepa and A. Ligeza\n%\n% HeaRT thermostat case\n%\n%\n%     Copyright (C) 2004-6 by A. Ligeza, G. J. Nalepa\n%     Copyright (C) 2006-9 by the HeKatE Project\n%\n%     HeaRT has been develped by the HeKatE Project, \n%     see http://hekate.ia.agh.edu.pl\n%\n%     This file is part of HeaRT.\n%\n%     HeaRT is free software: you can redistribute it and/or modify\n%     it under the terms of the GNU General Public License as published by\n%     the Free Software Foundation, either version 3 of the License, or\n%     (at your option) any later version.\n%\n%     HeaRT is distributed in the hope that it will be useful,\n%     but WITHOUT ANY WARRANTY; without even the implied warranty of\n%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n%     GNU General Public License for more details.\n%\n%     You should have received a copy of the GNU General Public License\n%     along with HeaRT.  If not, see <http://www.gnu.org/licenses/>.\n%\n\n%:- ensure_loaded('heart.pl').\n%\n% Thermostat Named Types definitions\n%\n% FIXME:\n%  - state all defaults\n%  - basic? for basic type, any better name?\n%\n% HINTS\n% - named types names should be plural, or general, eg. says\nxtype [name: week_days,\n       base: symbolic,\n       %default -> scale: none,\n       %default -> group: root,\n       ordered: yes,		% default: no\n       domain: [monday,tuesday,wednesday,thursday,friday,saturday,sunday],\n%       domain: [monday,tuesday,wednesday,thursday,friday,saturday,sunday],\n%      if the domain is oreder and no numbering is used we can still use it, numbering starts with 1\n%       domain: [monday/10,tuesday/12,wednesday/15,thursday/28,friday/4,saturday/34,sunday/3],\n% domains are FULLY ordered -> unique numbers\n       desc: 'some description'\n       %NOPE abbrev: [mon,tue,wed,thr,fri,sat,sun]\n      ]. \nxtype [name: type_of_day,\n       base: symbolic,\n       domain: [weekend,workday]\n      ].\n%xtype [name: month_days,\n%       base: numeric,\n%       domain: [1 to 31]\n%       ].\nxtype [name: hours,\n       base: numeric,\n       domain: [0 to 23]\n       ].\nxtype [name: biz_hours,\n       base: symbolic,\n       domain: [during_bizhours,not_bizhours]\n      ].\nxtype [name: months,\n       base: symbolic,\n       domain: [january,february,march,april,may,june,july,august,september,october,november,december],\n       ordered: yes\n      ].\nxtype [name: seasons,\n       base: symbolic,\n       domain: [spring,summer,autumn,winter],\n       ordered: yes\n      ].\nxtype [name: 'Temperature',\n       base: numeric,\n       %scale: none,\n       domain: [0 to 30]\n      ].\n\nxtpgr [name:   'A General Date',\n       abbrev: 'Date',\n       types:  [hours,months]\n      ].\n\n%\n% Thermostat Attribute definitions\n%\n% FIXME:\n%  - state all defaults + domains\n%xattr [name:  STRING, % unique name\n%       class: simple|general\n%       type:  STRING, % valid type name!\n%       comm:  in|out|inter|comm,\n%       desc:  STRING, % optional\n%       abbrev: STRING % optional\n%      ].\n\nxattr [name:  day,\n       class: simple,\n       type:  week_days,\n       comm:  in,\n	   callback: io_ask_att_gui(day)\n	   ].\nxattr [name:  hour,\n       class: simple,\n       type:  hours,\n       comm:  in,\n	   callback: io_ask_att_gui(hour)\n	   ].\nxattr [name:  today,\n       class: simple,\n       type:  type_of_day,\n       comm:  inter].\nxattr [name:  operation,\n       class: simple,\n       type:  biz_hours,\n       comm:  inter\n      ].\nxattr [name:  month,\n       class: simple,\n       type:  months,\n       comm:  in,\n       callback: io_ask_att_gui(month)\n      ].\nxattr [name:  season,\n       class: simple,\n       type:  seasons,\n       comm:  inter].\nxattr [name:  therm_set,    %mandatory!\n       class: simple,       %mandatory!\n       type: 'Temperature', %mandatory!\n       comm: out,            %mandatory!\n       callback: io_tell_att_console(therm_set)\n%      callback: 'write_att(therm_set).'      \n       % default = \n       % default = callback: none,\n       % default = abbrev: none,\n       % default = desc: none\n      ].\n%xattr [name: '',\n%       class: ,\n%       type:  ,\n%       comm:  ].\n\n% api:\n%  add attribute\n%  add type\n\nxatgr [name:   'A General Date',\n       abbrev: 'Date',\n       types:  [date,time]\n      ].\n\n% null in state!\n% saving trajectory mode\n\nxschm ms: [month] ==> [season].\nxschm dt: [day] ==> [today].\nxschm th: [today,hour] ==> [operation].\nxschm os: [operation,season] ==> [therm_set].\n%NIY: os/'desc' handling\n\n% xrule syntax:\n% xrule TableID/RuleID:\n%  [Att1 ALSVOP1 Val1,\n%   Att2 ALSVOP2 Val2,\n%    . . .\n%   Attn ALSVOPn Valn]\n%  ==>\n%  [AttX set ValX,\n%    . . .\n%   AttY set ExprY] % settheoretic or arithm in case on numeric atts\n%  **>\n%   [some_registered_action(Att1,AttN), % with legal (see scheme!) attributes\n%    prolog_built_in_pred]\n%  :DestTableId/DestRuleId. % optional, can also be just :DestTableId. (rule2table link)\nxrule ms/1:\n  [month in [january,february,december]]\n  ==>\n  [season set summer].\nxrule ms/2:\n  [month in [march,april,may]]\n  ==>\n  [season set autumn]\n  :os.\nxrule ms/3:\n  [month in [june,july,august]]\n  ==>\n  [season set winter]\n%  **>\n%  [write(month)]\n  :os/3.\nxrule ms/4:\n  [month in [9,10,11]] %in [september,october,november]]\n  ==>\n  [season set winter]\n  :os.\n\nxrule dt/1:\n  [day in [monday,tuesday,wednesday,thursday,friday]]\n  % FIXME: in case of general atts w/ ordered domain it should be possible to write\n  % [mon to fri] as <mon,fri> FIXME how to support <,) and (,> ???\n  ==>\n  [today set workday].%,\n%   today set ah].\n%  **>\n%  [kot,ma,ale].\nxrule dt/2:\n  [day in [saturday,sunday]]\n  ==>\n  [today set weekend].\n  \nxrule th/1:\n  [today eq workday,\n   hour  gt 17]\n  ==>\n  [operation set not_bizhours].\nxrule th/2:\n  [today eq weekend,\n   hour  eq any]\n  ==>\n  [operation set not_bizhours].\nxrule th/3:\n  [today eq workday,\n   hour  lt 9]\n  ==>\n  [operation set not_bizhours].\nxrule th/4:\n  [today eq workday,\n   hour  in [9 to 17]]\n  ==>\n  [operation set during_bizhours].\n\nxrule os/1:\n  [operation eq not_bizhours,\n   season eq summer]\n  ==>\n  [therm_set set 27].\nxrule os/2:\n  [operation eq during_bizhours,\n   season eq summer]\n  ==>\n  [therm_set set 24].\nxrule os/3:\n  [operation eq not_bizhours,\n   season eq spring]\n  ==>\n  [therm_set set 15].\nxrule os/4:\n  [operation eq during_bizhours,\n   season eq spring]\n  ==>\n  [therm_set set 20].\nxrule os/5:\n  [operation eq during_bizhours,\n   season eq winter]\n  ==>\n  [therm_set set 18].\nxrule os/6:\n  [operation eq not_bizhours,\n   season eq winter]\n  ==>\n  [therm_set set 14].\nxrule os/7:\n  [operation eq not_bizhours,\n   season eq autumn]\n  ==>\n  [therm_set set 16].\nxrule os/8:\n  [operation eq during_bizhours,\n   season eq autumn]\n  ==>\n  [therm_set set 20].\n\n%FIXME three letters alsv operators\n\nxstat s1: [day,'monday'].\nxstat s1: [hour,13].\nxstat s1: [month,'january'].\n\nxstat s2: [day,sunday].\nxstat s2: [hour,8].\nxstat s2: [month,'march'].\n\nxstat s3: [day,tuesday].\nxstat s3: [hour,19].\nxstat s3: [month,'march'].\n\ngo:- go1.\ngo1:- gox(s1,[ms,dt,th,os]).\ngo2:- gox(s2,[ms,dt,th,os]).\ngo3:- gox(s3,[ms,dt,th,os]).\ngoio1 :- goxio([ms,dt,th,os]).")
print(response)

response = myLib.getModelList()
print(response)		

response = myLib.getUserModel("Michal","python")
print(response)

response = myLib.removeUserModel("Michal","python")
print(response)

response = myLib.getModelList()
print(response)	

response = myLib.runSimulation("Michal","moj model",1,"tab1,tab2","[]")
print(response)

response = myLib.getProtocolVersion()
print(response)

response = myLib.verifyModel("Michal","moj model",1)
print("ver: " + response)
